#include "nvmediapath/nvmediapath.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#ifdef _WIN32
#include "windows.h"
#endif

void LocateMediaFile( char *filename, char *pathname, char *fullpathname )
{
    FILE *fp;
    int found;
    int trys;
    int i;

#ifdef _WIN32
    /*
     * This code is requied to make this function work when
     * running the program from a directory perhaps above
     * where the SDK is located.  For example, if launching
     * from an html link that lives above the directory where
     * the SDK is installed.
     */
    char name[512];
    char *chPtr;
    GetModuleFileName( NULL, name, 512 );
    chPtr = strrchr( name, '\\' );
    if ( chPtr != NULL )
    {
        *chPtr = '\0';
        SetCurrentDirectory( name );
    }
#endif

    found = 0;
    for ( trys = 0; trys < 6; trys++ )
    {
        /* construct the full path name */
        fullpathname[0] = '\0';
        for ( i = 0; i < trys; i++ )
        {
            strcat( fullpathname, "../" );
        }
        strcat( fullpathname, pathname );
        strcat( fullpathname, filename );
        fp = fopen( fullpathname, "rb" );
        if ( fp != NULL )
        {
            found = 1;
            fclose( fp );
            break;
        }
    }
    if ( !found )
    {
#ifdef _WIN32
        char message[512];
        sprintf( message, "Unable to locate the media file: %s.\nApplication will now exit.", filename );
        MessageBox( 0, message, "LocateMediaFile() Error", MB_OK );
#endif
        fprintf( stderr, "Unable to locate the file: %s\n", filename );
        exit( -1 );
    }
}

