#include "nvtexture/nvtexture.h"
#include "nvdds/nvdds.h"
#include <stdlib.h>

int LoadTextureDDS( char *filename )
{
    NVDDSImage *pImage = NULL;    
    int w, h;
    int m;
    int level;

    pImage = NVDDSLoad( filename );
    if ( pImage == NULL ) return 0;
    w = pImage->width;
    h = pImage->height;
    level = 0;
    while ( w > 256 || h > 256 )
    {
        level++;
        w = (w == 1) ? w : w >> 1;
        h = (h == 1) ? h : h >> 1;
    }
    for ( m = 0; level < pImage->numMipmaps; level++, m++ )
    {
        glCompressedTexImage2D( GL_TEXTURE_2D, m, pImage->format, w, h, 0, pImage->size[level], pImage->data[level] );
        w = (w == 1) ? w : w >> 1;
        h = (h == 1) ? h : h >> 1;
    }
    NVDDSFree( pImage );

    return 1;
}
